from copy import copy


def list_and_dict(l, d):
    result_string = ""
    i = 0

    for key, val in d.items():
        if val in l:
            result_string += key + ", "
        else:
            found = False
            while i < len(l) and not found:
                number = l[i]
                if l[i] not in d.values():
                    found = True
                    d[key] = number
                i += 1

    return result_string, d


def main():
    l = [12, 3, -4, 6, -5, 9]
    d = {"apple": 3, "orange": 4, "tomato": -5, "meat": 6, "potato": 15, "strawberry": 9}
    print(*list_and_dict(l, d), d)
    print()

    d = {"apple": 3, "orange": 4, "tomato": -5, "meat": 6, "potato": 15, "strawberry": 9}
    print(*list_and_dict(l, copy(d)), d)


if __name__ == "__main__":
    main()
